/*
 * Smart GWT (GWT for SmartClient)
 * Copyright 2008 and beyond, Isomorphic Software, Inc.
 *
 * Smart GWT is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation.  Smart GWT is also
 * available under typical commercial license terms - see
 * http://smartclient.com/license
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 */
/* sgwtgen */
 
package com.smartgwt.client.ai;


import com.smartgwt.client.event.*;
import com.smartgwt.client.core.*;
import com.smartgwt.client.types.*;
import com.smartgwt.client.data.*;
import com.smartgwt.client.data.Record;
import com.smartgwt.client.data.events.*;
import com.smartgwt.client.browser.window.*;
import com.smartgwt.client.rpc.*;
import com.smartgwt.client.ai.*;
import com.smartgwt.client.callbacks.*;
import com.smartgwt.client.tools.*;
import com.smartgwt.client.bean.*;
import com.smartgwt.client.widgets.*;
import com.smartgwt.client.widgets.ai.*;
import com.smartgwt.client.widgets.events.*;
import com.smartgwt.client.widgets.form.*;
import com.smartgwt.client.widgets.form.validator.*;
import com.smartgwt.client.widgets.form.fields.*;
import com.smartgwt.client.widgets.tile.*;
import com.smartgwt.client.widgets.tile.events.*;
import com.smartgwt.client.widgets.grid.*;
import com.smartgwt.client.widgets.grid.events.*;
import com.smartgwt.client.widgets.chart.*;
import com.smartgwt.client.widgets.layout.*;
import com.smartgwt.client.widgets.layout.events.*;
import com.smartgwt.client.widgets.menu.*;
import com.smartgwt.client.widgets.tour.*;
import com.smartgwt.client.widgets.notify.*;
import com.smartgwt.client.widgets.rte.*;
import com.smartgwt.client.widgets.rte.events.*;
import com.smartgwt.client.widgets.ace.*;
import com.smartgwt.client.widgets.ace.events.*;
import com.smartgwt.client.widgets.tab.*;
import com.smartgwt.client.widgets.toolbar.*;
import com.smartgwt.client.widgets.tree.*;
import com.smartgwt.client.widgets.tree.events.*;
import com.smartgwt.client.widgets.tableview.*;
import com.smartgwt.client.widgets.viewer.*;
import com.smartgwt.client.widgets.calendar.*;
import com.smartgwt.client.widgets.calendar.events.*;
import com.smartgwt.client.widgets.cube.*;
import com.smartgwt.client.widgets.notify.*;
import com.smartgwt.client.widgets.drawing.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.google.gwt.event.shared.*;
import com.google.gwt.dom.client.Element;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.core.client.JavaScriptObject;

import com.smartgwt.client.util.*;
import com.smartgwt.client.util.events.*;
import com.smartgwt.client.util.workflow.*;
import com.smartgwt.client.util.workflow.Process; // required to override java.lang.Process
import com.smartgwt.client.util.tour.*;


/**
 * 
 */
@BeanFactory.FrameworkClass
public class SuggestRecordSummaryTitleResult extends AsyncOperationResult {

    public static SuggestRecordSummaryTitleResult getOrCreateRef(JavaScriptObject jsObj) {
        if (jsObj == null) return null;

        final RefDataClass existingObj = RefDataClass.getRef(jsObj);

        if (existingObj instanceof SuggestRecordSummaryTitleResult) {
            existingObj.setJsObj(jsObj);
            return (SuggestRecordSummaryTitleResult)existingObj;
        } else

        {
            return new SuggestRecordSummaryTitleResult(jsObj);
        }
    }
        


    public SuggestRecordSummaryTitleResult(){
        
    }

    public SuggestRecordSummaryTitleResult(JavaScriptObject jsObj){
        
        setJavaScriptObject(jsObj);
    }



    // ********************* Properties / Attributes ***********************

    /**
     * If set, the list of field names that are potentially relevant to the record summary requests.<br> If unset, either the
     * {@link com.smartgwt.client.ai.SuggestRecordSummaryTitleRequest} was unsuccessful or no determination was made as to the
     * potentially relevant field names.
     *
     * @param relevantFieldNames New relevantFieldNames value. Default value is null
     * @return {@link com.smartgwt.client.ai.SuggestRecordSummaryTitleResult SuggestRecordSummaryTitleResult} instance, for chaining setter calls
     * @see com.smartgwt.client.docs.FieldName FieldName 
     */
    public SuggestRecordSummaryTitleResult setRelevantFieldNames(String... relevantFieldNames) {
        return (SuggestRecordSummaryTitleResult)setAttribute("relevantFieldNames", relevantFieldNames);
    }

    /**
     * If set, the list of field names that are potentially relevant to the record summary requests.<br> If unset, either the
     * {@link com.smartgwt.client.ai.SuggestRecordSummaryTitleRequest} was unsuccessful or no determination was made as to the
     * potentially relevant field names.
     *
     * @return Current relevantFieldNames value. Default value is null
     * @see com.smartgwt.client.docs.FieldName FieldName 
     */
    public String[] getRelevantFieldNames()  {
        return com.smartgwt.client.util.ConvertTo.arrayOfString(getAttributeAsJavaScriptObject("relevantFieldNames"));
    }
    

    /**
     * If successful, the AI-generated suggestion for a title of a field that will contain the AI-generated record summaries.
     * <p> The suggested title will not be <code>null</code>, will be trimmed of leading and trailing whitespace, and will not
     * be an empty string.
     *
     * @param suggestedTitle New suggestedTitle value. Default value is null
     * @return {@link com.smartgwt.client.ai.SuggestRecordSummaryTitleResult SuggestRecordSummaryTitleResult} instance, for chaining setter calls
     */
    public SuggestRecordSummaryTitleResult setSuggestedTitle(String suggestedTitle) {
        return (SuggestRecordSummaryTitleResult)setAttribute("suggestedTitle", suggestedTitle);
    }

    /**
     * If successful, the AI-generated suggestion for a title of a field that will contain the AI-generated record summaries.
     * <p> The suggested title will not be <code>null</code>, will be trimmed of leading and trailing whitespace, and will not
     * be an empty string.
     *
     * @return Current suggestedTitle value. Default value is null
     */
    public String getSuggestedTitle()  {
        return getAttributeAsString("suggestedTitle");
    }
    

    // ********************* Methods ***********************

    // ********************* Static Methods ***********************

    // ***********************************************************

}
