package com.smartgwt.client.types;


/*
 * Smart GWT (GWT for SmartClient)
 * Copyright 2008 and beyond, Isomorphic Software, Inc.
 *
 * Smart GWT is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation.  Smart GWT is also
 * available under typical commercial license terms - see
 * http://smartclient.com/license
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 */
/* sgwtgen */
 
/**
 * Defines the various types of record that can be present in a {@link com.smartgwt.client.widgets.grid.ListGrid}.
 */
public enum RecordType implements ValueEnum {
    /**
     * regular data-records
     * <P>
     * If this enumerated value is used in a {@link com.smartgwt.client.docs.ComponentXML Component XML}
     * file or server-side DataSource descriptor (.ds.xml file), use the value "normal".
     */
    NORMAL("normal"),
    /**
     * a special collapsable record containing related regular records
     * <P>
     * If this enumerated value is used in a {@link com.smartgwt.client.docs.ComponentXML Component XML}
     * file or server-side DataSource descriptor (.ds.xml file), use the value "groupHeader".
     */
    GROUPHEADER("groupHeader"),
    /**
     * a record showing summaries for all records in a parent groupNode
     * <P>
     * If this enumerated value is used in a {@link com.smartgwt.client.docs.ComponentXML Component XML}
     * file or server-side DataSource descriptor (.ds.xml file), use the value "groupSummary".
     */
    GROUPSUMMARY("groupSummary"),
    /**
     * a record showing summaries for all records in the grid
     * <P>
     * If this enumerated value is used in a {@link com.smartgwt.client.docs.ComponentXML Component XML}
     * file or server-side DataSource descriptor (.ds.xml file), use the value "gridSummary".
     */
    GRIDSUMMARY("gridSummary");
    private String value;

    RecordType(String value) {
        this.value = value;
    }

    public String getValue() {
        return this.value;
    }
}
